import java.util.*;

/**
 * Risposta al comando 'ASK RAYS'.
 */
public class RaysResponse extends Response
{

    Vector items;
    
    public RaysResponse() {
    	items = new Vector();
    }

    public void setValue(String[] v) {
    	// v[0] = "OK"
    	for(int i=1; i<v.length; i+=5) {
	    	// v[i] = numero progressivo del raggio
	    	// v[i+1] = nome dell'oggetto
			// v[i+2] = posizione x
			// v[i+3] = posizione y
			// v[i+4] = posizione z
	    	float x = Float.parseFloat(v[i+2]);
	    	float y = Float.parseFloat(v[i+3]);
	    	float z = Float.parseFloat(v[i+4]);
	    	items.addElement(new Item(v[i+1],x,y,z));
		}
    }

    /**
     * Restituisce una stringa contenente la risposta al comando.
     * @return Una stringa contenente la risposta al comando.
     */
    public String dumpValue() {
    	String value="";
    	for(int i=0; i<items.size(); ++i)
    		value=value+((Item)items.get(i)).dump()+"\n";
    	return value;
    }

/**
 * Restituisce una lista contenente la risposta al comando.
 * @return Una stringa contenente la risposta al comando sottoforma di lista.
 */
public String dumpList() {
	String value="";
	if(items.size()==0) {
		value="[]";
	} else {
		value="["+((Item)items.get(0)).dumpList();
		for(int i=1; i<items.size(); ++i)
			value=value+","+((Item)items.get(i)).dumpList();
		value=value+"]";
	}
	return value;
}
}
