% COMANDI DISPONIBILI: 	TURN, WALK, STAND, RADIUS, RAYS
% STATI DISPONIBILI: 		OBSERVE, CAPTURE


% nextCmd(+PrevCmdStory,+TellState,+CmdResponse,+PrevAgentState,
%	-NextCmd,-NextPar,-NextCmdStory,-NextAgentState)
%		PrevCmdStory: storico attuale dei comandi eseguiti
%		TellState: stato attuale della risposta TELL
%		CmdResponse: lista contenente la risposta all'ultimo comando eseguito
%		PrevAgentState: stato attuale dell'agente
% 		NextCmd: prossimo comando da eseguire
%		NextPar: parametro del comando da eseguire (0 se non applicabile)
%		NextCmdStory: storico aggiornato dei comandi eseguiti
%		NextAgentState: nuovo stato dell'agente dopo l'esecuzione del comando

nextCmd([start],_,_,STATE,CMD,PAR,STOR,STATE):-CMD is turn, PAR is 90, STOR is [turn].

nextCmd([turn|PSTOR],_,_,observe,CMD,PAR,STOR,STATE):- CMD is walk, PAR is 50, STATE is observe, 
	union([turn],PSTOR,STOR1), union([walk],STOR1,STOR).
nextCmd([turn|PSTOR],_,_,capture,CMD,PAR,STOR,STATE):- CMD is walk, PAR is 100, STATE is capture, 
	union([turn],PSTOR,STOR1), union([walk],STOR1,STOR).
	
nextCmd([radius|PSTOR],_,_,STATE,CMD,PAR,STOR,STATE):-CMD is walk, PAR is 50, 
	union([radius],PSTOR,STOR1), union([walk],STOR1,STOR).

nextCmd([stand|PSTOR],_,_,STATE,CMD,PAR,STOR,STATE):- CMD is walk, PAR is 50, 
	union([stand],PSTOR,STOR1), union([walk],STOR1,STOR).

nextCmd([rays|PSTOR],_,_,STATE,CMD,PAR,STOR,STATE):- CMD is walk, PAR is 50, 
	union([rays],PSTOR,STOR1), union([walk],STOR1,STOR).

nextCmd([walk|TSTOR],_,_,observe,CMD,PAR,STOR,STATE):-countPreviousWalk(TSTOR,0,COUNT,_), COUNT==0,
	CMD is walk, PAR is 50, STATE is observe, union([walk],TSTOR,STOR1), union([walk],STOR1,STOR).
nextCmd([walk|TSTOR],_,_,observe,CMD,PAR,STOR,STATE):-countPreviousWalk(TSTOR,0,COUNT,[turn|TAIL]), COUNT==1,
	CMD is radius, PAR is 100, STATE is observe, union([walk],TSTOR,STOR1),union([radius],STOR1,STOR).
nextCmd([walk|TSTOR],_,_,observe,CMD,PAR,STOR,STATE):-countPreviousWalk(TSTOR,0,COUNT,[radius|TAIL]), COUNT==1,
	CMD is turn, PAR is 180, STATE is observe, union([walk],TSTOR,STOR1),union([turn],STOR1,STOR).
nextCmd([walk|TSTOR],_,_,observe,CMD,PAR,STOR,STATE):-countPreviousWalk(TSTOR,0,COUNT,[stand|TAIL]), COUNT==1,
	CMD is radius, PAR is 100, STATE is observe, union([walk],TSTOR,STOR1),union([radius],STOR1,STOR).
nextCmd([walk|TSTOR],_,_,observe,CMD,PAR,STOR,STATE):-countPreviousWalk(TSTOR,0,COUNT,[rays|TAIL]), COUNT==1,
	CMD is radius, PAR is 100, STATE is observe, union([walk],TSTOR,STOR1),union([radius],STOR1,STOR).

nextCmd([walk|TSTOR],_,_,capture,CMD,PAR,STOR,STATE):- CMD is walk, PAR is 100, STATE is capture, 
	union([walk],TSTOR,STOR1), union([walk],STOR1,STOR).
			
% countPreviousWalk(+CmdStory,+CountBase,-Count,-Tail)
%		CmdStory: storico dei comandi su cui eseguire la verifica
%		CountBase: valore iniziale da cui iniziare a contare (normalmente 0)
%		Count: numero di occorrenze consecutive del comando WALK a partire dalla testa dello storico
%		Tail: parte restante dello storico dei comandi dopo la rimozione dei comandi WALK conteggiati

countPreviousWalk([turn|TAIL],COUNT,COUNT,TAIL1):-union([turn],TAIL,TAIL1).
countPreviousWalk([stand|TAIL],COUNT,COUNT,TAIL1):-union([stand],TAIL,TAIL1).
countPreviousWalk([radius|TAIL],COUNT,COUNT,TAIL1):-union([radius],TAIL,TAIL1).
countPreviousWalk([rays|TAIL],COUNT,COUNT,TAIL1):-union([rays],TAIL,TAIL1).
countPreviousWalk([walk|TAIL],PCOUNT,COUNT,TAIL1):-countPreviousWalk(TAIL,PCOUNT,PCOUNT1,TAIL1),COUNT is PCOUNT1+1.

% union(+M1,+M2,-Mout), aggiunge M2 in coda ad M1
union([],M1,M1).
union([M|Ms],M1,[M|Mo]):-union(Ms,M1,Mo).

% member(?E,?M,?O), trova tutte le occorrenze di E in M e restituisce il resto in o
member(E,[E|T],T).
member(E,[H|T],[H|R]):-member(E,T,R).