(import java.awt.*)
(import java.awt.image.*)
(import java.io.*)
(import javax.swing.*)
(import jess.awt.*)
(import java.lang.*)

(defglobal

	?*quake* = 0 ; Holds the QuagentDemoII object

	;can be (goto), (get-situation), (idle), (turnY), (walkX), or (walkY)
	?*current-goal* = 0 

	?*return-value* = 0 ;holds Response class for movement
	?*current-situation* = 0 ;holds Response class for misc methods	

	?*current-angle* = 0 ;all angles are relative to starting angle being 0 degrees

	;go to which x and y offsets
	?*goto-x* = 0 
	?*goto-y* = 0

	?*tired-of-walking* = 0 ;until the agent gets tired of walking, it won't look around
)

(deffunction initialize ()
  	(bind ?*quake* (new QuagentDemoII))
	(?*quake* initialize)
	(bind ?*tired-of-walking* 100)
	(bind ?*current-goal* (assert (idle)))
)

(deffunction close ()
	(?*quake* close)
)

(defrule find-new-behavior-walk
	"agent has completed last behavior, and is not to tired to keep walking"
	(idle)
	(test (> ?*tired-of-walking* 0))
	=>
	(bind ?*tired-of-walking* (- ?*tired-of-walking* 25))
	(retract ?*current-goal*)
	(bind ?*current-goal* 	(assert (goto)))
	(bind ?*goto-x* (?*quake* randInt))
	(bind ?*goto-y* (?*quake* randInt))
)

(defrule find-new-behavior-look
	"agent has completed last behavior, and is too tired to keep walking"
	(idle)
	(test (<= ?*tired-of-walking* 0))
	=>
	(bind ?*tired-of-walking* 100) 
	(retract ?*current-goal*)
	(bind ?*current-goal* (assert (get-situation)))
)

(defrule look-around
	(get-situation)
	=>
	(bind ?*current-situation* (?*quake* probe 100))
	(retract ?*current-goal*)
	(bind ?*current-goal* (assert (idle)))
	(printout t "Agent takes a look around" crlf)
)


;To move, the agent turns to its relative postive X-axis,
;Then goes x steps
;Then turns to its relative Y-axis
;Then goes y steps

(defrule need-to-move 
	"agent is not where it should be, begin by turning to the x"
	(goto)
	=>
	(bind ?*return-value* (?*quake* turn (- 90 ?*current-angle*)))
	(retract ?*current-goal*)
	(bind ?*current-goal* (assert (walkX)))
	(printout t "Agent turns x" crlf)
)

(defrule walk-X
	(walkX)
	=>
	(bind ?*return-value* (?*quake* walk ?*goto-x*))
	(retract ?*current-goal*)
	(bind ?*current-goal* (assert (turnY)))
	(printout t "Agent walks x" crlf)
)

(defrule turn-Y
	(turnY)
	=>
	(bind ?*return-value* (?*quake* turn 90))
	(retract ?*current-goal*)
	(bind ?*current-goal* (assert (walkY)))
	(printout t "Agent turns y" crlf)
)

(defrule walk-Y
	(walkY)
	=>
	(bind ?*return-value* (?*quake* walk ?*goto-y*))
	(retract ?*current-goal*)
	(bind ?*current-goal* (assert (idle)))
	(printout t "Agent walks y" crlf)
)

(reset)

(initialize)

(run)

(close)