import java.net.*;
import java.io.*;
import java.nio.*;
import java.nio.channels.*;
import java.util.*;
import java.lang.*;

/**
 */
public class QuagentDemoII {

    private SocketChannel sChannel;
    private DrunkenMasterII agent;

    //Connect to the quake server and create a bot
    public void initialize(){
	 try{
	      sChannel = SocketChannel.open();
	      sChannel.configureBlocking(false);

	      // connection the server; this method is non-blocking
	      sChannel.connect(new InetSocketAddress("localhost", 33333));

	      System.out.println("Connecting...");

	      while (!sChannel.finishConnect()) {
	      }

	      agent = new DrunkenMasterII(sChannel);
	 }
	 catch (UnknownHostException e1) {
	     System.out.println("UnknownHostException:" + e1.getMessage());
	 } catch (ConnectException e2){
	     
	     System.out.println("ConnectException:" + e2.getMessage());
	 } catch (IOException e3){
	     
	     System.out.println("IO Error:" + e3.getMessage());
	 }
	 System.out.println("Initialized");

    }

    //disconnect from the quake server
    public void close(){
	try{
	    sChannel.socket().close();
	    sChannel.close();
	} catch (UnknownHostException e1) {
	    System.out.println("UnknownHostException:" + e1.getMessage());
	} catch (ConnectException e2){
	    
	    System.out.println("ConnectException:" + e2.getMessage());
	} catch (IOException e3){
	    
	    System.out.println("IO Error:" + e3.getMessage());
	}
	System.out.println("Closed");

    }

    //walk a certain distance
    public Response walk(int dist){
	System.out.println("Walking...");
	try{
	    Thread.sleep(2000);
	}catch (InterruptedException e) { }
	return agent.walk(dist);
    }

    //probe a certain radius
    public Response probe(int radius){
	System.out.println("Probing...");
	try{
	    Thread.sleep(2000);
	}catch (InterruptedException e) { }
	return agent.probe(radius);
    }

    //turn a certain angle
    public Response turn(int angle){
	System.out.println("Turning...");
	/*try{
	    Thread.sleep(2000);
	    }catch (InterruptedException e) { }*/
	return agent.turn(angle);
    }

    //helper function to generate a random integer for random
    //walking behaviors
    public int randInt(){
	return (int) (Math.random() * 100);

    }
}

