;Wumpus World solver
;Pete Barnum pbarnum@cs.rochester.edu

(import java.awt.*)
(import java.awt.image.*)
(import java.io.*)
(import javax.swing.*)
(import jess.awt.*)

;Java interfacing

(defglobal
	?*board* = 0
	?*window* = 0
	?*container* = 0)

(deffunction closer (?event)
   (if (= (call ?event getID) (get-member ?event WINDOW_CLOSING)) then 
     (call (get ?event source) dispose)
     (call java.lang.System exit 0)))

(deffunction initialize-1 ()

  	(bind ?*board* (new wumpus "images/"))

	(bind ?*window* (new javax.swing.JFrame "Wumpus World"))
	(?*window* addWindowListener (new jess.awt.WindowListener closer (engine)))

	(bind ?*container* (?*window* getContentPane))
	(?*container* add ?*board*)

	(?*window* pack)
	(?*window* setSize 500 500)
	(?*window* show)
)



;Actual wumpus-world solving behavior

(deftemplate player
	(slot name)
	(slot x (type INTEGER))
	(slot y (type INTEGER))
	(slot alive)
	(slot gold (type INTEGER))
)


(deffunction initialize-2 ()
	(assert (player (name Orion) (x (?*board* getX)) (y (?*board* getY)) (alive TRUE) (gold 0)))
)

(defrule moveX
	?thePlayer <- (player (x ?x) (y ?y) (alive TRUE))
	(test (< ?x 1))
	=>
	(?*board* move_right)
	(modify ?thePlayer (x (?*board* getX)))
	(printout t "Player Position (" (?*board* getX) ","  (?*board* getY) ")" crlf)
)

(defrule moveY
	?thePlayer <- (player (x ?x) (y ?y) (alive TRUE))
	(test (< ?y 3))
	=>
	(?*board* move_down)
	(modify ?thePlayer (y (?*board* getY)))
	(printout t "Player Position (" (?*board* getX) ","  (?*board* getY) ")" crlf)
)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Put things together and display
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;(create-components)

(reset)
(initialize-1)
(initialize-2)

(run)
