%{
#include <stdlib.h>
#include "y.tab.h"
%}
%%
#.* ;
[+-]?(([0-9]+)|([0-9]*\.[0-9]+)([eE][-+]?[0-0]+)?) {yylval.value=atof(yytext); return NUMBER;}

quagent|Quagent|QUAGENT {return QUAGENT;}
type|Type|TYPE {return QUAGENT_TYPE;}
initiallocation|InitialLocation|INITIALLOCATION {return QUAGENT_POSITION;}
lifetime|LIFETIME           {yylval.index=LIFETIME; return LIFETIME;}
initialwisdom|INITIALWISDOM {yylval.index=INITIALWISDOM; return INITIALWISDOM;}
initialenergy|INITIALENERGY {yylval.index=INITIALENERGY; return INITIALENERGY;}
initialwealth|INITIALWEALTH {yylval.index=INITIALWEALTH; return INITIALWEALTH;}
initialhealth|INITIALHEALTH {yylval.index=INITIALHEALTH; return INITIALHEALTH;}
energylowthrehold|ENERGYLOWTHRESHOLD {yylval.index=ENERGYLOWTHRESHOLD ; return ENERGYLOWTHRESHOLD ;}
agehighthrehold|AGEHIGHTHRESHOLD {yylval.index=AGEHIGHTHRESHOLD ; return AGEHIGHTHRESHOLD ;}

box|BOX                {yylval.index=BOX; return BOX;}
tofu|TOFU              {yylval.index=TOFU; return TOFU;}
battery|BATTERY        {yylval.index=BATTERY; return BATTERY;}
gold|GOLD              {yylval.index=GOLD; return GOLD;}
data|DATA              {yylval.index=DATA; return DATA;}
kryptonite|KRYPTONITE  {yylval.index=KRYPTONITE; return KRYPTONITE;}
head|HEAD              {yylval.index=HEAD; return HEAD;}

berserk|BERSERK|Randal|randal {yylval.index=BERSERK; return BERSERK;}
chick|CHICK|Sandhya|sandhya {yylval.index=CHICK; return CHICK;}
gladiator|GLADIATOR|Lane|lane {yylval.index=GLADIATOR; return GLADIATOR;}
gunner|GUNNER|Dana|dana {yylval.index=GUNNER; return GUNNER;}
infantry|INFANTRY|Michael|michael {yylval.index=INFANTRY; return INFANTRY;}
parasite|PARASITE|Chris|chris|CB {yylval.index=PARASITE; return PARASITE;}
soldier|SOLDIER|Mitsu|mitsu {yylval.index=SOLDIER; return SOLDIER;}
mutant|MUTANT|Mutant|George|george {yylval.index=MUTANT; return MUTANT;}
float|FLOAT|Float {yylval.index=FLOAT; return FLOAT;}

[ \t] ;
. return yytext[0];
%%
