/**
 * Implementa la descrizione di un oggetto collocato in un punto di una mappa attraverso il suo nome
 * e la sua posizione.
 */
public class Item {

    String name;
    float x, y, z;

    /**
     * Costruttore della classe, crea un oggetto Item,
     * @param name Nome dell'oggetto.
     * @param x Posizione dell'oggetto nella direzione x.
     * @param y Posizione dell'oggetto nella direzione y.
     * @param z Posizione dell'oggetto nella direzione z.
     */
    public Item(String name, float x, float y, float z) {
		this.name = name;
		this.x = x;
		this.y = y;
		this.z = z;
    }

    /**
     * Ritorna una stringa contenente nome e posizione dell'oggetto.
     * @return Una stringa contenente nome e posizione dell'oggetto.
     */
    public String dump() {
    	return name+" "+x+" "+ y + " " + z;
    }
    
    /**
     * Ritorna una lista contenente nome e posizione dell'oggetto nella forma [nome,x,y,z].
     * @return Una stringa contenente nome e posizione dell'oggetto sottoforma di lista.
     */
    public String dumpList() {
    	return "obj("+name+","+x+","+ y + "," + z +")";
    }

}