/**
 * Implementa la descrizione di un evento sollevato dall'agente Quagent (messaggio di tipo TELL).
 */
public class QuagentEvent {

    private String type;
    private String value;

    /**
     * Costruttore della classe.
     * @param v Notifica dell'evento letta dal canale di comunicazione.
     */
    public QuagentEvent(String[] v) {
		type = v[0];
		value = v[1];
		for(int i=2; i<v.length; ++i)
		    value = value+ " " +v[i];
    }

    /**
     * Ritorna il valore dell'evento.
     * @return Stringa contenente il valore dell'evento.
     */
    public String value() {
    	return value;
    }

    /**
     * Ritorna la tipologia dell'evento.
     * @return Stringa contenente la tipologia dell'evento.
     */
    public String type() {
    	return type;
    }
}
