import java.util.*;

/**
 * Risposta al comando 'ASK RADIUS'.
 */
public class RadiusResponse extends Response
{

    Vector items;
    
    public RadiusResponse() {

	items = new Vector();
    }

    public void setValue(String[] v) {

	// v[0] is "OK"
	// v[1] is number of items

	for(int i=2; i<v.length; i+=4) {

	    // v[i] has the name of the item
	    // v[i+1] has the position

	    float x = Float.parseFloat(v[i+1]);
	    float y = Float.parseFloat(v[i+2]);
	    float z = Float.parseFloat(v[i+3]);

	    items.addElement(new Item(v[i],x,y,z));
	}

    }

    /**
     * Restituisce una stringa contenente la risposta al comando.
     * @return Una stringa contenente la risposta al comando.
     */
    public String dumpValue() {
    	String value="";
    	if(items.size()==0)
    		value="NOTHING";
    	else
    		for(int i=0; i<items.size(); ++i)
    			value=value+((Item)items.get(i)).dump()+" ";
    	return value;
    }

    /**
     * Restituisce una lista contenente la risposta al comando.
     * @return Una stringa contenente la risposta al comando sottoforma di lista.
     */
    public String dumpList() {
    	String value="";
    	if(items.size()==0) {
    		value="[]";
    	} else {
    		value="["+((Item)items.get(0)).dumpList();
			for(int i=1; i<items.size(); ++i)
				value=value+","+((Item)items.get(i)).dumpList();
			value=value+"]";
    	}
    	return value;
    }
}